<?
	/*
		Functions.php
		Bestandteil des Firebooks
		[WMP] Guestbook Contest
		(c) 2003 by Firebird
		
		Dieses Programm ist freie Software. 
		Sie knnen es unter den Bedingungen der GNU General Public License,
		wie von der Free Software Foundation verffentlicht,
		weitergeben und/oder modifizieren, entweder gem Version 2 der Lizenz
		oder (nach Ihrer Option) jeder spteren Version. 
		
		Die Verffentlichung dieses Programms erfolgt in der Hoffnung,
		da es Ihnen von Nutzen sein wird, aber OHNE IRGENDEINE GARANTIE,
		sogar ohne die implizite Garantie der MARKTREIFE oder der
		VERWENDBARKEIT FR EINEN BESTIMMTEN ZWECK. Details finden Sie in
		der GNU General Public License. 
	*/
		
	// Template Funktion
	// Puffer fr Templates, zur Performance erhhung
	$templatebuffer = array();
	function getTPL($templatename, $admintpls = false)
	{
		global $templatebuffer, $Style;
		// Ordner whlen (ACP oder Normale Templates)
		$usefolder = ($admintpls ? CONST_TEMPLATEFOLDER_ADMIN : CONST_TEMPLATEFOLDER);
		
		// Template laden
		if(!isset($templatebuffer[$templatename]))
			if(file_exists($usefolder."/".$templatename.".htm"))
			{
				$text = implode("", file($usefolder."/".$templatename.".htm"));
				$templatebuffer[$templatename] = str_replace("\\'","'",addslashes($text));
				
				// Style-Tags umwandeln
				foreach($Style as $Styleentry => $Replace)
					$templatebuffer[$templatename] = str_replace("{{".$Styleentry."}}", $Replace['Value'], $templatebuffer[$templatename]);
			}
			else raiseCriticalError("Template nicht gefunden: ".getcwd().$usefolder."/$templatename.htm", "getTPL");
		return $templatebuffer[$templatename];
	}
	
	// Fehler auslsen
	function raiseCriticalError($errorText, $functionRaising)
	{
		ob_end_clean();
		die("<b>Fehler</b><br><br>Es ist ein Fehler aufgetreten. Die Programmausfhrung kann nicht
		 fortgesetzt werden.<br><br>In Funktion '$functionRaising':<br><i>$errorText</i><br><br>");
	}
	
	// Admin Rechte (Boolische Rckgabe)
	function gotAdminRights()
	{
		global $HTTP_AUTHORIZATION;
		global $PHP_AUTH_USER;
		global $PHP_AUTH_PW;
		global $Settings;
		
		// Windows Bug beheben - IIS sendet keine entschlsselten Daten mit
		if (ereg("^Basic ", $HTTP_AUTHORIZATION) && !isset($PHP_AUTH_USER)) 
  		{ 
  			list($PHP_AUTH_USER, $PHP_AUTH_PW) = explode(":", base64_decode(substr($HTTP_AUTHORIZATION, 6))); 
  		}
  		
  		// User & Passwort prfen
  		if(md5($PHP_AUTH_PW) != $Settings['adminpass'] || $PHP_AUTH_USER != $Settings['adminuser'])
  			return false;
  			
  		return true;
	}
	
	// Admin Rechte ntig
	function needAdminRights($reason = "Administration")
	{
		global $HTTP_AUTHORIZATION;
		global $PHP_AUTH_USER;
		global $PHP_AUTH_PW;
		global $Settings;
		
		// Windows Bug beheben - IIS sendet keine entschlsselten Daten mit
		if (ereg("^Basic ", $HTTP_AUTHORIZATION) && !isset($PHP_AUTH_USER)) 
  		{ 
  			list($PHP_AUTH_USER, $PHP_AUTH_PW) = explode(":", base64_decode(substr($HTTP_AUTHORIZATION, 6))); 
  		}
  		
  		if(!isset($PHP_AUTH_USER)) 
  		{
  			// "Keine ausreichenden Rechte" senden
  			Header("WWW-Authenticate: Basic realm=\"$reason\"");
      		Header("HTTP/1.1 401 Authorization Required");
      		Header("Connection: close");
      		eval("die(\"".getTPL("rights")."\");");
  		}
  		
  		// User & Passwort prfen
  		if(md5($PHP_AUTH_PW) != $Settings['adminpass'] || $PHP_AUTH_USER != $Settings['adminuser'])
  		{
  			// Log schreiben
  			if(!isset($Settings['Accessatemps'])) $Settings['Accessatemps'] = "";
  			$currTime = gmdate("d.m.y H:i:s", time() + (($Settings['time_zone'] + date("I")) * 3600));
  			
  			$Settings['Accessatemps'] .= "<li>[".$currTime."] User ".addHtmlSlashes($_SERVER['REMOTE_ADDR'])." (". addHtmlSlashes($_SERVER['HTTP_USER_AGENT']).")<br>Ort: ".$reason."<br>Passwort: ".addHtmlSlashes($PHP_AUTH_PW)."<br>User: ".addHtmlSlashes($PHP_AUTH_USER)."<br></li>\n";
			saveSettings();
			  			
  			// "Keine ausreichenden Rechte" senden
  			Header("WWW-Authenticate: Basic realm=\"$reason\"");
      		Header("HTTP/1.1 401 Authorization Required");
      		Header("Connection: close");
      		eval("die(\"".getTPL("rights")."\");");
  		}
  		else Header("HTTP/1.1 200 OK");
	}
	
	// Stripslashes Cross-Array
	function stripslashesinarray(&$array) {
 		reset($array);
 		// Array durchlaufen
 		while(list($key,$val) = each($array)) {
  			if(is_string($val)) 
  			{
  				// Strip Slashes
	  			$array[$key] = stripslashes($val);
  			}
  			elseif(is_array($val))
  				// Rekursiv aufrufen
	  			$array[$key] = stripslashesinarray($val);
 		}
 		return $array;
	}
	
	// Addslashes Cross-Array
	// Gleiches Prinzip wie Stripslashes
	function addslashesinarray(&$array) {
 		reset($array);
 		while(list($key,$val) = each($array)) {
  			if(is_string($val)) 
  			{
	  			$array[$key] = addslashes($val);
  			}
  			elseif(is_array($val))
	  			$array[$key] = addslashesinarray($val);
 		}
 		return $array;
	}
	
	// HTML Encode Cross-Array
	// Gleiches Prinzip wie Stripslashes
	function htmlconvertinarray(&$array) {
 		reset($array);
 		while(list($key,$val) = each($array)) {
  			if(is_string($val)) 
  			{
	  			$array[$key] = addHtmlSlashes($val);
  			}
  			elseif(is_array($val))
	  			$array[$key] = htmlconvertinarray($val);
 		}
 		return $array;
	}
	
	// HTML Special Chars Methode
	// Zum leichten ndern & Hinzufgen eine extra Funktion
	function addHtmlSlashes($text)
	{
		// Translation Table laden
		$translation_table = get_html_translation_table(HTML_ENTITIES);
		
		/*
			INFO: Strtr erfordert eigentlich 3 Parameter.
		          Da Translation_Table allerdings ein
		          Array ist, ist dies nicht erforderlich
		*/
		return strtr($text, $translation_table);
	}
	
	// IP Sperre - Prfen ob die IP bereits existiert
	function IPExisting()
	{
		global $Entrys;
		foreach($Entrys as $Entry)
			// Wenn sie existiert braucht man Admin Rechte um die Sperre zu bergehen
			if($Entry['IP'] == $_SERVER['REMOTE_ADDR']) needAdminRights("IP Sperre");
	}
	
	// Rechte des Eintrags prfen - Man muss Besitzer oder Admin sein um darauf zuzugreifen
	function needRights($EntryId)
	{
		global $Entrys, $Settings;
		if($Settings['allow_edit'] == 1 && $Entrys[$EntryId]['IP'] == $_SERVER['REMOTE_ADDR']) return true;
		needAdminRights("Beitrag bearbeiten");
	}
	
	// Applywordwrap - Zeilenumbruch erzwingen
	function applyWordWrap($text)
	{
		global $Settings;
		if($Settings['wordwrap'] == 0) return $text;
		
		// Zuerst sich wiederholende Buchstaben trimmen
		// Die "freundliche" Wordwrap Version
		/*
			INFO: ord gibt den Ascii Wert eines Zeichens zurck
			      chr gibt das Zeichen eines Ascii Wertes zurck
		*/
		for($i=ord("A"); $i<256; $i++)
			$text = preg_replace("/(\\x".dechex($i).")\\x".dechex($i)."{20,}([^\\x".dechex($i)."]|$)/siU", "$1$1$1...$2", $text);
			
		// Reste? Gnadenlos trimmen.
		return wordwrap($text, $Settings['wordwrap'], " ", 1);
	}
	
	// ICQ Sendmessage
	// Eine Nachricht in ICQ verschicken
	function icqSendMessage($targetUIN, $text)
	{
		global $Settings;
		
		// String formatieren
		$sendString = "nickname=Firebird&to=".$targetUIN."&from=Firebook&fromemail=mail@firebook&body=".urlencode($text);
		
		// Socket ffnen
		$icqServer = @fsockopen("web.icq.com", 80, $errno, $errdesc, 50);
		if($icqServer)
		{
			// Daten senden
			fwrite($icqServer, "POST /whitepages/page_me/1,,,00.html HTTP/1.1\n");
			fwrite($icqServer, "Host: web.icq.com\n");
			fwrite($icqServer, "Content-type: application/x-www-form-urlencoded\n");
			fwrite($icqServer, "Content-Length: ".strlen($sendString)."\n\n");
			fwrite($icqServer, $sendString);
			// Socket schlieen
			fclose($icqServer);
		}
	}
	
	// Parser Funktion
	// Eines der Kernstcke des Programmes
	// Ersetzt GBCode, Smilies, etc. beim Parsen der Beitrge
	function parseEntry($entry, $EntryId)
	{
		global $Settings, $Smilies, $Gbcodes, $Fields, $Style;
		// colorCounter wird fr die unterschdl. Tabellenfarben bentigt
		static $colorCounter;
		$colorCounter++;
		
		// Nachricht extrahieren
		$message = $entry['Message'];
				
		// HTML aktivieren/deaktivieren
		if($Settings['allowhtml'] == 1 && $entry['HTML'] == 1)
		{
			$message = str_replace("<script","&ltscript",$message);
			$message = str_replace("</script", "&lt/script", $message);
   			$message = str_replace("<table", "&lttable", $message);
   			$message = str_replace("</table", "&lt/table", $message);
		} else $message = addHtmlSlashes($message);
		
		// Url's automatisch ersetzen
		if($Settings['replaceurls'] == 1)
		{
			// HTTP-Urls
			while(preg_match("/( |^)http:\/\/(.*)( |$)/sUmi", $message))
				$message = preg_replace("/( |^)http:\/\/(.*)( |$)/sUmi", " <a href=\"http://$2\">http://$2</a> ", $message);
			// www.de Urls
			while(preg_match("/( |^)www.(.*)\.(de|com|net|biz|at)( |$)/sUmi", $message))
				$message = preg_replace("/( |^)www.(.*)\.(de|com|net|biz|at)( |$)/sUmi", " <a href=\"http://www.$2.$3\">www.$2.$3</a> ", $message);
		}
		
		// Zeilenumbrche durch <br> ersetzen
		$message = nl2br($message);
		
		// Smilies einsetzen
		if($Settings['allowsmilies'] == 1 && $entry['Smilies'] == 1)
		{
			foreach($Smilies as $Smilie)
				$message = str_replace($Smilie['Code'], "<img alt='$Smilie[Code]' src='".CONST_SMILIEFOLDER."/$Smilie[File]'>", $message);
		}
		
		// Upper to Lower Funktion
		if($Settings['uppertolower'] == 1)
		{
			if(strtoupper($message) == $message) $message = strtolower($message);
		}
		
		// GBCode umwandeln
		if($Settings['allowgbc'] == 1 && $entry['GBCode'] == 1)
		{
			foreach($Gbcodes as $Gbcode)
			{
				// Diese Funktion arbeitet mit sprintf aus C++, um Platz zu sparen
				
				if(strpos($Gbcode['After'], "[param2]"))
					// 2 Parameter
					$needle = "/\[%s=(.*)](.*)\[\/%s\]/siU";
				elseif(strpos($Gbcode['After'], "[param1]"))
					// Ein Parameter
					$needle = "/\[%s](.*)\[\/%s\]/siU"; 
				else 
					// Ohne Parameter
					$needle = "/\[%s]/siU"; 
				
				// Parameter Marker in Regex Code umwandeln
				$replace = str_replace("[param1]", "\$1", $Gbcode['After']);
				$replace = str_replace("[param2]", "\$2", $replace);
					
				$needle = sprintf($needle, $Gbcode['Pre'], $Gbcode['Pre']);
				
				// Alle Vorkommen ersetzen
				while(preg_match($needle, $message))
					$message = preg_replace($needle, $replace, $message);
			}
		}
		
		// Preview oder Anzeigen - Beim Preview ist Fields nicht gesetzt
		if(isset($entry['Fields'])) 
			$Fields = htmlconvertinarray($entry['Fields']);
		else 	
			$Fields = htmlconvertinarray($_POST);

		// Wortfilter
		if(isset($Settings['wordfilter']) && $Settings['wordfilter'] != "")
		{
			$censored = explode("\r\n", $Settings['wordfilter']);
			foreach($censored as $replace)
				if(trim($replace) != "") while(preg_match("/(\>| |^)[^\>\s]*".addcslashes(trim($replace),"\\^$.[]|()?!*+{}")."[\S]*(}\<| |$)/simU", $message))
					$message = preg_replace("/(^| |\>)[^\>\s]*".addcslashes(trim($replace),"\\^$.[]|()?!*+{}")."[\S]*(\<| |$)/simU", "$1-zensiert-$2", $message);
		}
		
		// Den Admin Nick hervorheben
		if(isset($Fields['Nick']) && $Fields['Nick'] == $Settings['adminuser'])
			$formatedNick = str_replace("[param1]", $Fields['Nick'], $Style['highlightadmin']['Value']);
		else
			$formatedNick = $Fields['Nick'];
		
		// Zeit formatiert anzeigen [Sommerzeit bercksichtigen]
		if(isset($entry['Time']))
			$Posttime = gmdate($Settings['time_format'], $entry['Time'] + (($Settings['time_zone'] + date("I")) * 3600));
		else 	
			// Preview, hier gibt es keine Zeit
			$Posttime = gmdate($Settings['time_format'], time() + (($Settings['time_zone'] + date("I")) * 3600));
					
		// Wochentage auf Deutsch - geht auch direkt, aber dann kann
		// der Date() Standard nicht benutzt werden, da strftime() eine
		// andere Syntax hat
		$Posttime = preg_replace("/Monday/siU", "Montag", $Posttime);
		$Posttime = preg_replace("/Tuesday/siU", "Dienstag", $Posttime);
		$Posttime = preg_replace("/Wednesday/siU", "Mittwoch", $Posttime);
		$Posttime = preg_replace("/Thursday/siU", "Donnerstag", $Posttime);
		$Posttime = preg_replace("/Friday/siU", "Freitag", $Posttime);
		$Posttime = preg_replace("/Saturday/siU", "Samstag", $Posttime);
		$Posttime = preg_replace("/Sundas/siU", "Sonntag", $Posttime);
		
		// Kommentar anhngen
		$comment = "";
		if(isset($entry['comment']))
		{
			$entry['comment'] = nl2br(addHtmlSlashes($entry['comment']));
			eval("\$comment = \"".getTPL("msg_comment")."\";");
		}
		
		
		// Template ausgeben
		if($colorCounter % 2 == 0)
			eval("\$retval = \"".getTPL("msg2")."\";");
		else 
			eval("\$retval = \"".getTPL("msg1")."\";");
			
		// Code zurckgeben
		return $retval;
	}
?>